#ifndef _process_text_tables_h_
#define _process_text_tables_h_

#define NUM_LANGUAGES 18
 
typedef struct { const char * lang; const char * utf8; const char * latin1; } process_language_table_entry;
typedef struct { const char * lang[NUM_LANGUAGES]; } process_string_table_entry;
 
extern process_language_table_entry process_language_table[NUM_LANGUAGES];
extern process_string_table_entry process_string_table[];

#define TXT_NULL 0
#define TXT_FILTER_NAME 1
#define TXT_FILTER_NAMES 2
#define TXT_OBJECT_LONG_NAME 3
#define TXT_DATE_FROM 4
#define TXT_DATE_TO 5
#define TXT_GROUP_BY 6
#define TXT_DATE 7
#define TXT_OBJECT 8
#define TXT_SORT_BY 9
#define TXT_TIME 10
#define TXT_CONN_DURATION 11
#define TXT_DIRECTION 12
#define TXT_SORT_ORDER 13
#define TXT_SORT_ASCENDING 14
#define TXT_SORT_DESCENDING 15
#define TXT_HIDE_DIGITS 16
#define TXT_NO_RECORDS 17
#define TXT_LEFT 18
#define TXT_RIGHT 19
#define TXT_CONFERENCE_ID 20
#define TXT_CALL_FLOW 21
#define TXT_TYPE 22
#define TXT_ALERT_DURATION 23
#define TXT_CALL_DURATION 24
#define TXT_BILLING_DURATION 25
#define TXT_OBJECT_GROUPS 26
#define TXT_NODE 27
#define TXT_PBX 28
#define TXT_CAUSE 29
#define TXT_CALLBACK 30
#define TXT_STATUS 31
#define TXT_TODAY 32
#define TXT_YESTERDAY 33
#define TXT_DATE_FORMAT 34
#define TXT_INCOMING 35
#define TXT_OUTGOING 36
#define TXT_DURATION 37
#define TXT_DISPLAYED_DURATION 38
#define TXT_FURTHER_REG 39
#define TXT_CALL 40
#define TXT_REMOTE_PARTY 41
#define TXT_YES 42
#define TXT_NO 43
#define TXT_ANONYM 44
#define TXT_SUMMARY_IO 45
#define TXT_SUMMARY_CALLS_IO 46
#define TXT_SUMMARY_DURATION_IO 47
#define TXT_SUMMARY_ALERT_IO 48
#define TXT_SYSTEM_NAME 49
#define TXT_REPORT_LIMIT 50
#define TXT_EMPTY 51
#define TXT_SPACE 52


#define COUNT_TXT_ITEMS 53


#endif
