#!/bin/sh
# 

trap "on_error; exit 1" INT QUIT TERM

innovaphone_tmp=""
innovaphone_app_tmp=""
app=""
xml_tmp=""
process_tmp=""
replication_sh_tmp=""
replication_out_tmp=""
reporting_cleanup_tmp=""
installed_packages=""
uninstall_tmp=""
install_tmp=""
config_tmp=""
check_tmp=""
boot_tmp=""
boot_end_tmp=""
inno_logs_tmp=""
inno_rsyslog_tmp=""
inno_rsyslog_conf_tmp=""
lighty_tmp=""
mime_tmp=""
rpcapd_tmp=""
repseq_tmp=""
faxseq_tmp=""
exseq_tmp=""
main_template_tmp=""
process=0
lighttpd=0
custom_declared=0
psql1_tmp=""
psql2_tmp=""
psql3_tmp=""
rsyslog_logs_tmp=""

function on_exit()
{
    if [ -n "${innovaphone_tmp}" ]; then
        rm -R -f ${innovaphone_tmp}
    fi
    if [ -n "${innovaphone_app_tmp}" ]; then
        rm -R -f ${innovaphone_app_tmp}
    fi
    if [ -n "${process_tmp}" ]; then
        rm -f ${process_tmp}
    fi
    if [ -n "${replication_sh_tmp}" ]; then
        rm -f ${replication_sh_tmp}
    fi
    if [ -n "${reporting_cleanup_tmp}" ]; then
        rm -f ${reporting_cleanup_tmp}
    fi
    if [ -n "${replication_out_tmp}" ]; then
        rm -f ${replication_out_tmp}
    fi
    if [ -n "${uninstall_tmp}" ]; then
        rm -f ${uninstall_tmp}
    fi
    if [ -n "${config_tmp}" ]; then
        rm -f ${config_tmp}
    fi
    if [ -n "${check_tmp}" ]; then
        rm -f ${check_tmp}
    fi
    if [ -n "${inno_logs_tmp}" ]; then
        rm -f ${inno_logs_tmp}
    fi
    if [ -n "${rsyslog_logs_tmp}" ]; then
        rm -f ${rsyslog_logs_tmp}
    fi
    if [ -n "${inno_rsyslog_tmp}" ]; then
        rm -f ${inno_rsyslog_tmp}
    fi
    if [ -n "${inno_rsyslog_conf_tmp}" ]; then
        rm -f ${inno_rsyslog_conf_tmp}
    fi
    if [ -n "${boot_tmp}" ]; then
        rm -f ${boot_tmp}
    fi
    if [ -n "${boot_end_tmp}" ]; then
        rm -f ${boot_end_tmp}
    fi
    if [ -n "${lighty_tmp}" ]; then
        rm -f ${lighty_tmp}
    fi
    if [ -n "${mime_tmp}" ]; then
        rm -f ${mime_tmp}
    fi
    if [ -n "${rpcapd_tmp}" ]; then
        rm -f ${rpcapd_tmp}
    fi
    if [ -n "${install_tmp}" ]; then
        rm -f ${install_tmp}
    fi
    if [ -n "${repseq_tmp}" ]; then
        rm -f ${repseq_tmp}
    fi
    if [ -n "${faxseq_tmp}" ]; then
        rm -f ${faxseq_tmp}
    fi
    if [ -n "${exseq_tmp}" ]; then
        rm -f ${exseq_tmp}
    fi
    if [ -n "${psql1_tmp}" ]; then
        rm -f ${psql1_tmp}
    fi
    if [ -n "${psql2_tmp}" ]; then
        rm -f ${psql2_tmp}
    fi
    if [ -n "${psql3_tmp}" ]; then
        rm -f ${psql3_tmp}
    fi
    if [ -n "${main_template_tmp}" ]; then
        rm -f ${main_template_tmp}
    fi
    if [ -n "${xml_tmp}" ]; then
        rm -f ${xml_tmp}
    fi
    if [ ${custom_declared} -eq 1 ]; then
        on_exit_custom
    fi
}

function on_error()
{
    if [ -n "${installed_packages}" ]; then
        apt-get -y --force-yes purge ${installed_packages}
	    apt-get autoremove
    fi
    if [ -n "${innovaphone_tmp}" ]; then
        /etc/init.d/lighttpd stop
        cp -p -R ${innovaphone_tmp}/* /var/www/innovaphone
        /etc/init.d/lighttpd start
    fi
    if [ -n "${innovaphone_app_tmp}" ]; then
        cp -p -R ${innovaphone_app_tmp}/* /var/www/innovaphone/apps/${app}
    fi
    if [ -n "${process_tmp}" ]; then
        cp -p ${process_tmp} /var/www/innovaphone/process.fcgi
    fi
    if [ -n "${replication_sh_tmp}" ]; then
        cp -p ${replication_sh_tmp} /usr/local/bin/reporting_replication.sh
    fi
    if [ -n "${reporting_cleanup_tmp}" ]; then
        cp -p ${reporting_cleanup_tmp} /usr/local/bin/reporting_cleanup.sh
    fi
    if [ -n "${replication_out_tmp}" ]; then
        cp -p ${replication_out_tmp} /usr/local/bin/reporting_replication.out
    fi
    if [ -n "${uninstall_tmp}" ]; then
        cp -p ${uninstall_tmp} /usr/local/bin/uninstall_script.sh
    fi
    if [ -n "${config_tmp}" ]; then
        cp -p ${config_tmp} /usr/local/bin/config.sh
    fi
    if [ -n "${check_tmp}" ]; then
        cp -p ${check_tmp} /etc/cron.d/innovaphone_check
    fi
    if [ -n "${inno_logs_tmp}" ]; then
        cp -p ${inno_logs_tmp} /etc/logrotate.d/innovaphone-logs
    fi
    if [ -n "${rsyslog_logs_tmp}" ]; then
        cp -p ${rsyslog_logs_tmp} /etc/logrotate.d/rsyslog
    fi
    if [ -n "${inno_rsyslog_tmp}" ]; then
        cp -p ${inno_rsyslog_tmp} /etc/rsyslog.d/innovaphone-syslog.conf
        /etc/init.d/rsyslog restart
    fi
    if [ -n "${inno_rsyslog_conf_tmp}" ]; then
        cp -p ${inno_rsyslog_conf_tmp} /etc/rsyslog.conf
        /etc/init.d/rsyslog restart
    fi
    if [ -n "${boot_tmp}" ]; then
        cp -p ${boot_tmp} /etc/init.d/bootscript
    fi
    if [ -n "${boot_end_tmp}" ]; then
        cp -p ${boot_end_tmp} /etc/init.d/zbootscript_end
    fi
    if [ -n "${lighty_tmp}" ]; then
        cp -p ${lighty_tmp} /etc/init.d/lighttpd
    fi
    if [ -n "${mime_tmp}" ]; then
        cp -p ${mime_tmp}  /usr/share/mutt
    fi
    if [ -n "${repseq_tmp}" ]; then
        cp -p ${repseq_tmp} /home/postgres/restore/
    fi
    if [ -n "${faxseq_tmp}" ]; then
        cp -p ${faxseq_tmp} /home/postgres/restore/
    fi
    if [ -n "${exseq_tmp}" ]; then
        cp -p ${exseq_tmp} /home/postgres/restore/
    fi
    if [ -n "${psql1_tmp}" ]; then
        cp -p ${psql1_tmp} /home/postgres/restore/
    fi
    if [ -n "${psql2_tmp}" ]; then
        cp -p ${psql2_tmp} /home/postgres/restore/
    fi
    if [ -n "${psql3_tmp}" ]; then
        cp -p ${psql3_tmp} /home/postgres/restore/
    fi
    if [ -n "${main_template_tmp}" ]; then
        cp -p ${main_template_tmp} /home/lighttpd/server_config/main_template
    fi
    if [ -n "${rpcapd_tmp}" ]; then
        running=`ps aux | grep -v grep | grep rpcapd | wc -l`
        if [ ${running} -gt 0 ]; then
            ps aux | grep -v grep | grep rpcapd | awk '{ print $2 }' | xargs kill -9
        fi
        cp -p ${rpcapd_tmp} /usr/local/bin
        if [ ${running} -gt 0 ]; then
            /usr/local/bin/rpcapd -p 2002 -4 -n -d > /dev/null 2>&1
        fi
    fi
    if [ -n "${install_tmp}" ]; then
        cp -p ${install_tmp} /usr/local/bin/install_script.sh
    fi
    if [ -n "${xml_tmp}" ]; then
        cp -p ${xml_tmp} /var/www/innovaphone/apps/${app}.xml
    fi
    if [ ${custom_declared} -eq 1 ]; then
        on_error_custom
    fi
    on_exit
}


function install_packages() 
{
    sources_list="/etc/apt/sources.list"
    if [ -d debian/packages ]; then
        if [ -n "$(dpkg -l '*' | grep '^i[^iU]')" -o -n "$(dpkg -C)" ]; then
            dpkgl=`dpkg -l '*' | grep '^i[^iU]'`
            dpkgc=`dpkg -C`
            echo "ERROR: $(date '+%Y-%m-%d %H:%M:%S') - Debian packages can't be installed: ${dpkgl} ${dpkgc}" 
            on_error
            exit 1
        fi
        cd debian/packages
        installed_packages=`ls -1 *.deb | cut -d"_" -f1 | xargs`
        cd ../..
        if [ ! -n "${installed_packages}" ]; then
            echo "LOG: $(date '+%Y-%m-%d %H:%M:%S') - No debian packages to install"
        else
            echo "LOG: $(date '+%Y-%m-%d %H:%M:%S') - Install debian packages ${installed_packages}"
            mv debian/packages/*.deb /var/cache/apt/archives
            mv debian/packages/Packages.gz /var/cache/apt/archives
            mv ${sources_list} ${sources_list}.tmp
            echo "deb file:///var/cache/apt/archives /" > ${sources_list}
            apt-get update
            tmp=""
            if [ "$1" = "install" ]; then
                installed_tmp=""
                for d in $installed_packages; do
                    p_installed=`dpkg -l | egrep -oe "[a-zA-Z]{2}[ ]*$d"`
                    if [ -z "$p_installed" ]; then
                        installed_tmp="$installed_tmp $d"
                    else
                        echo "LOG: $(date '+%Y-%m-%d %H:%M:%S') - Package $d already installed"
                    fi
                done
                apt-get -y --force-yes install ${installed_packages}
                apt_res=$?
                installed_packages=$installed_tmp
            elif [ "$1" = "upgrade" ]; then
                installed_packages=""
                tmp=`apt-get -y --force-yes upgrade`
                apt_res=$?
                echo $tmp
            fi
            apt-get clean
            mv ${sources_list}.tmp ${sources_list}
            apt-get update
            update_res=$?
            if [ ! ${apt_res} -eq 0 ]; then
                echo "ERROR: $(date '+%Y-%m-%d %H:%M:%S') - Installation of debian packages failed"
                on_error
                exit 1
            fi
            if echo $tmp | grep "The following packages have been kept back" >/dev/null
            then
                if [ "$1" = "upgrade" ]; then
                    missing=`echo $tmp | sed 's/.*have been kept back: \+\(.*\) \+The \+following \+packages \+will \+be \+upgraded.*/\1/'`
                    #if [ ${update_res} -eq 0 ]; then
                    #    echo "LOG: $(date '+%Y-%m-%d %H:%M:%S') - Trying to install missing package dependencies from internet: ${missing}..."
                    #    apt-get -y --force-yes upgrade
                    #    update_res=$?
                    #else
                    #    echo "LOG: $(date '+%Y-%m-%d %H:%M:%S') - Can't install missing package dependencies from internet, as 'apt-get update' failed"
                    #fi
                    echo "LOG: $(date '+%Y-%m-%d %H:%M:%S') - Some package dependencies are missing!"
                    tmp_file="/var/www/innovaphone/log/missing_packages.log"			 
                    echo ${missing} > $tmp_file
                    chmod 755 $tmp_file
                    chown www-data:www-data $tmp_file
                fi
            fi
        fi
    else
        echo "LOG: $(date '+%Y-%m-%d %H:%M:%S') - No debian packages to install"
    fi
}

app=image
chmod 755 *.sh
chmod 755 debian/*.sh
./check_platform.sh platform
if [ $? -ne 0 ]; then
    exit 1
fi
./check_version.sh 10406 /var/www/innovaphone/version 36 0 image linux-1/image
if [ ! $? -eq 0 ]; then
    exit 1
fi
 
 
innovaphone_tmp=`mktemp -d /tmp/innovaphone_XXXXXXXX`
./php_template.sh www-data www-data debian/innovaphone /var/www/innovaphone ${innovaphone_tmp}
 
 
tmp_dir=""

# will be called in on_error, automatically added by make.sh
function on_error_custom() 
{
    echo -n ""
}

# will be called in on_exit, automatically added by make.sh
function on_exit_custom()
{
    echo -n ""
}

# only for vm
vm_runs=0
if [ -n "$(uname -m | egrep -oe 'i[0-9]{1}86')" ]; then
    vm_runs=1
fi

# call package install at first
custom_declared=1
install_packages install

 
 

#compile process.fcgi
process=1
process_tmp=`mktemp /tmp/process_XXXXXXXX`
cp -p /var/www/innovaphone/process.fcgi ${process_tmp}
cd debian
./compile_process.sh "/var/www/innovaphone"
cd ..
if [ ! -f "/var/www/innovaphone/process.fcgi.tmp" ]; then
    echo "ERROR: $(date '+%Y-%m-%d %H:%M:%S') - process.fcgi could not be compiled"
    on_error
    exit 1
fi

mv /var/www/innovaphone/process.fcgi.tmp /var/www/innovaphone/process.fcgi

 
 
echo -n 10408 > /var/www/innovaphone/version
echo -n 36 > /var/www/innovaphone/hotfix

# finish
if [ ${process} -eq 1 ] || [ ${lighttpd} -eq 1 ]; then
    if [ $1 ]; then
        echo 1 > /var/www/innovaphone/tmp/hotfix_lighttpd.restart
    else 
        echo "LOG: $(date '+%Y-%m-%d %H:%M:%S') - The web server will be restarted a few seconds after the installation!"
        echo "LOG: $(date '+%Y-%m-%d %H:%M:%S') - Installation was successful"
        sleep 10s
        php5-cgi /var/www/innovaphone/update_webserver_cfg.php
    fi
elif [ ! $1 ]; then
    echo "LOG: $(date '+%Y-%m-%d %H:%M:%S') - Installation was successful"
fi

on_exit
